/***************************************************************************
 *   Copyright (C) 2007-2008 by Peter Semiletov                            *
 *   peter.semiletov@gmail.com                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
** Copyright (C) 2006-2008 Trolltech ASA. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License versions 2.0 or 3.0 as published by the Free Software
** Foundation and appearing in the files LICENSE.GPL2 and LICENSE.GPL3
*/
/*
Diego Iastrubni <elcuco@kde.org> //some GPL'ed code from new-editor-diego-3, found on qtcentre forum
*/


#ifndef DOCUMENT_H
#define DOCUMENT_H

#include <QtGui>


typedef enum _TextType {
        Text_OFF = 0,
        Text_SINGLELINECOMMENT,
        Text_MULTILINECOMMENT,
        Text_STRING,
        Text_CHAR
} ;


class document_holder;
class CDocument;

/*
class CInformer:public QWidget
{
  Q_OBJECT

public:

  CInformer();
  ~CInformer();

  QMovie *movie;
  QLabel *label;

  void change_movie (const QString &file_name);

public slots:

  void movie_finished ();

protected:

  void mouseMoveEvent(QMouseEvent *event);
  void mousePressEvent(QMouseEvent *event);

private:

  QPoint dragPosition;
};
*/

class CTEAEdit: public QTextEdit
{
  Q_OBJECT

public:


  CDocument *doc;

  QColor currentLineColor;
  bool highlightCurrentLine;
  CTEAEdit (QWidget *parent = 0);
  ~CTEAEdit();
_TextType TextType;
//QCompleter *c;
//bool completer_enabled;

    /*bool canInsertFromMimeData(const QMimeData* source) const
    {
        return source->hasImage() || source->hasUrls() ||
            QTextEdit::canInsertFromMimeData(source);
    }
*/


  void setCurrentLineColor (QColor newColor);
  void setHightlighCurrentLine (bool enable);

  void dragEnterEvent (QDragEnterEvent *event);
  void dropEvent (QDropEvent *event);
//QString textUnderCursor() const;
//void setCompleter(QCompleter *completer);

void paintBracketForward(  QTextCursor & cur, int pos , const QChar & begin, const QChar & end);
void paintBracketBack(  QTextCursor & cur, int pos , const QChar & begin, const QChar & end);
bool exists( int pos );
int ending( int pos, const QChar &ch );
int forwarding( int pos, const QChar & ch );


private slots:
  //  void insertCompletion(const QString &completion);

  void cb_cursorPositionChanged();

protected:
 // void keyPressEvent(QKeyEvent *e);
  // void focusInEvent(QFocusEvent *e);

  void paintEvent(QPaintEvent *event);
};


class CLogMemo: public QObject
{
  Q_OBJECT

public:

//  CInformer *inf;
  QTextEdit *memo;

  CLogMemo (QTextEdit *m);

  void log (const QString &text, const QString &movie = QString());
};


class image_viewer:public QWidget
{
  Q_OBJECT

public:

  image_viewer(const QString &filename);
};


class CSyntaxHighlighter: public QSyntaxHighlighter
{
  Q_OBJECT

public:

  CSyntaxHighlighter (QTextDocument *parent = 0);

protected:

  void highlightBlock(const QString &text);

public:

  struct HighlightingRule
        {
         QRegExp pattern;
         QTextCharFormat format;
        };

  QVector<HighlightingRule> highlightingRules;

  QTextCharFormat singleLineCommentFormat;
  QTextCharFormat multiLineCommentFormat;

  QRegExp commentStartExpression;
  QRegExp commentEndExpression;

  void load_from_xml (const QString &fname);
};


class CDocument:public QObject
{
  Q_OBJECT

public:

  bool cursor_xy_visible;
  QCompleter *completer;

  QString markup_mode;
  document_holder *holder;
  CSyntaxHighlighter *highlighter;
  CTEAEdit *textEdit;
  QString file_name;
  QString text_to_search;
  QString charset;
  QWidget *tab_page;
  int position;

  CDocument(QObject *parent = 0);
  ~CDocument();

  void create_new (void);
  void set_tab_caption (const QString &fileName);
  bool save_with_name (const QString &fileName, const QString &codec);
  bool save_with_name_plain (const QString &fileName);
  void goto_pos (int pos);
  QString get_filename_at_cursor ();
  QStringList get_words();
  void set_hl ();
  bool open_file (const QString &fileName, const QString &codec);
  void set_markup_mode ();
  void reload (const QString &enc);
  int get_tab_idx (void);
  QString get_triplex();
  void update_status ();
  void update_title (bool fullname = TRUE);
};


class document_holder:public QObject
{
  Q_OBJECT

  public:

   QString fname_current_session;


  QLabel *l_status_bar;
  QString dir_config;
  QString fname_crapbook;

  QString markup_mode;
  //QFileSystemWatcher watcher;
  QStatusBar *status_bar;
  CLogMemo *log;
  QList<CDocument*> list;
  QMainWindow *parent_wnd;
  QTabWidget *tab_widget;
  QSettings *settings;

  QMenu *recent_menu;
  QStringList recent_files;
  QString recent_list_fname;
  QString fname_compdict;

  document_holder();
  ~document_holder();

  CDocument* create_new (void);
  CDocument* open_file (const QString &fileName, const QString &codec);
  CDocument* open_file_triplex (const QString &triplex);
  void reload_recent_list (void);


  void save_to_session (const QString &fileName);
  void load_from_session (const QString &fileName);


  void close_by_idx (int i);
  void close_current (void);
  void apply_settings (void);
  void apply_settings_single (CDocument *d);

  void add_to_recent (CDocument *d);
  void update_recent_menu ();

  CDocument* get_current ();

  public slots:

  void open_recent ();
  void watcher_fileChanged (const QString & path);

};


void create_menu_from_list (QObject *handler,
                            QMenu *menu,
                            const QStringList &list,
                            const char *method
                           );


#endif
