 /**************************************************************************
 *   Copyright (C) 2007-2008 by Peter Semiletov                            *
 *   peter.semiletov@gmail.com                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef RVLN_H
#define RVLN_H

#include <QtGui>
//#include <QHttp>


#include "document.h"

#ifdef ASPELL_ENABLE

#include "spellchecker.h"

#endif

/*
class CKeybSound: public QObject
{
  Q_OBJECT

public:

Phonon::MediaObject *mediaObject;
    Phonon::MediaObject *metaInformationResolver;
    Phonon::AudioOutput *audioOutput;


CKeybSound();
~CKeybSound();

  //signals:

 //void delPressed();

  protected:
            bool eventFilter(QObject *obj, QEvent *event);
};
*/

class CTvFmanKeyPressEater : public QObject
{
  Q_OBJECT

  signals:

 void delPressed();

  protected:
            bool eventFilter(QObject *obj, QEvent *event);
};


class CAboutWindow:public QWidget
{
  Q_OBJECT

public:

  CAboutWindow();

protected:

  void closeEvent(QCloseEvent *event);
};


class CShortcutEntry: public QLineEdit
{
  Q_OBJECT

public:

  void keyPressEvent (QKeyEvent *event);
};


class CShortcuts: public QObject
{
  Q_OBJECT

public:

  QWidget *w;
  QString fname;
  QHash <QString, QString> hash;
  QStringList captions;

  CShortcuts (QWidget *widget);
  void captions_iterate ();
  QAction* find_by_caption (const QString &text);
  QAction* find_by_shortcut (const QString &shcut);

  QKeySequence find_seq_by_caption (const QString &text);
  void set_new_shortcut (const QString &menuitem, const QString &shcut);

  void save_to_file (const QString &file_name);
  void load_from_file (const QString &file_name);
};


class rvln:public QMainWindow
{
  Q_OBJECT

public:
  rvln();
  ~rvln();

#ifdef ASPELL_ENABLE
  CSpellchecker *spellchecker;
#endif

  QSystemTrayIcon *tray;

//  CKeybSound *KeybSound;
  //QHttp http;
  //QHttpRequestHeader http_header;
  QToolBar *tb_fman_dir;
  QLabel *l_fman_preview;
  QTimer timer;
  int pbar_step;

  QStringList sl_places_bmx;

  QStringList sl_urls;
  QStringList sl_charsets;
  QStringList sl_last_used_charsets;
  QTranslator myappTranslator;
  CLogMemo  *log;
  //CInformer *inf;
  CShortcuts *shortcuts;

  QDir dir_lv;


  QDirModel *mvl_model;

//  QFileSystemModel *mvl_model;

  QListWidget *lw_fman;
  QListView *lv_fman;
  QTreeView *tv_fman;

  QString markup_mode;
  QPrinter printer;
  document_holder *documents;

  QSettings *settings;

  QString dir_last;
  QString dir_config;
  QString dir_templates;
  QString dir_sessions;

  QString dir_snippets;
  QString dir_scripts;

  QString fname_bookmarks;
  QString fname_compdict;
  QString fname_programs;
  QString fname_places_bookmarks;

  QString bookmarks;
  QString fname_crapbook;
  QString fname_tempfile;
  QString fname_tempparamfile;

  QLabel *l_status;
  QProgressBar *pb_status;

  QHash<QString, QString> programs;
  QHash<QString, QString> places_bookmarks;

protected:

  void closeEvent(QCloseEvent *event);
  bool fman_tv_eventFilter(QObject *obj, QEvent *event);


public slots:

        void activate();
        void handleMessage(const QString& message);


private slots:

/*************************
main window callbacks
*************************/

void tray_activated ( QSystemTrayIcon::ActivationReason reason );

void fman_create_dir();
void fman_add_bmk();
void fman_del_bmk();
void fman_open();

void fman_places_itemActivated ( QListWidgetItem * item );

  void cb_button_saves_as();

void fman_item_activated ( const QModelIndex & index );
void cb_fman_currentChanged ( const QModelIndex & current, const QModelIndex & previous );
void fman_home();

//   void slot_responseHeaderReceived (const QHttpResponseHeader &resp);

 void pageChanged (int index);

  void iterate_pbar();
  void file_print();

  void newFile();
  void open();
  void open_at_cursor();

  void file_open_bookmarks_file();
  void file_open_programs_file();

  void file_last_opened();
  void file_open_bookmark();
  void file_open_program();

  void file_add_to_bookmarks();
  void file_crapbook();

  void file_use_template();
  void file_use_snippet();
  void file_open_session();

  void file_save_version();

  void file_save_bak();
  void test();

  bool save();
  bool saveAs();

  void toggle_wrap();

  void about();
  void close_current();

  void ed_copy();
  void ed_paste();
  void ed_cut();

  void ed_undo();
  void ed_redo();
  void ed_clear();

  void upCase();
  void dnCase();

  void edit_copy_current_fname();
  void fn_enum();

  void fn_filter_with_regexp();
  void fn_text_stat();

  void fn_antispam_email();
  void fn_apply_to_each_line();
  void fn_reverse();
  void fn_evaluate();
  void fn_sort_casecare();
  void fn_flip_a_list();
  void fn_insert_loremipsum();
  void fn_insert_template_html();

  void fn_run_script();
  void cb_script_finished (int exitCode, QProcess::ExitStatus exitStatus);


  //void fn_suck_words();

  void fn_number_arabic_to_roman();
  void fn_number_roman_to_arabic();

  void fn_filter_rm_less_than();
  void fn_filter_rm_greater_than();
  void fn_filter_rm_duplicates();
  void fn_filter_rm_empty();
  void fn_rm_formatting();
  void fn_convert_quotes();

  void fn_extract_words();
  void fn_morse_from_en();
  void fn_morse_to_en();
  void fn_morse_from_ru();
  void fn_morse_to_ru();

  void fn_insert_date();
  void fn_insert_time();

  void fn_rm_formatting_at_each_line();

#ifdef ASPELL_ENABLE

  void fn_change_spell_lang();
  void fn_spell_check();
  void fn_spell_suggest_callback();
  void fn_spell_add_to_dict();
  void fn_spell_suggest();

#endif

  void mrkup_bold();
  void mrkup_italic();
  void mrkup_link();
  void mrkup_para();

  void mrkup_br();
  void mrkup_nbsp();
  void mrkup_tags_to_entities();
  void mrkup_mode_choosed();
  void mrkup_header();
  void mrkup_align();
  void mrkup_document_weight();

  void markup_ins_image();

  void mrkup_color();
  void mrkup_text_to_html();


  void search_find();
  void search_find_next();
  void search_find_prev();
  void search_replace_with();
  void search_replace_all();

  void remove_formatting();

  void view_preview_in_bro();
  void view_hide_error_marks();
  void view_toggle_fs();
  void view_stay_on_top();

  void nav_goto_line();
  void nav_goto_right_tab();
  void nav_goto_left_tab();
  void nav_toggle_hs();
  void nav_save_pos();
  void nav_goto_pos();
  void nav_focus_to_fte();
  void nav_focus_to_editor();

  void help_show_gpl();
  void help_show_news();
  void help_show_changelog();
  void help_show_todo();

  void session_save_as();

void fman_item_expanded ( const QModelIndex & index );
void fman_del_pressed ();
void fman_ed_commitData ( QWidget *editor );

/*************************
prefs window callbacks
*************************/
  void cb_locale_override (int state);
  void ed_locale_override_editingFinished ();

  void cb_session_restore (int state);

      //void cmb_translation_changed (const QString &s);
  //void cb_showroxvisor_changed (int state);
  void cb_wordwrap_changed (int state);

  #ifndef Q_WS_WIN

  void cb_use_trad_dialogs_changed (int state);

  #endif

  void pb_assign_hotkey_clicked ();
  void pb_remove_hotkey_clicked ();
  void slot_lv_menuitems_currentItemChanged ( QListWidgetItem *current, QListWidgetItem *previous);
  void slot_app_fontname_changed (const QString &text);
  void slot_editor_fontname_changed (const QString &text);
  void slot_font_size_changed (int i);
  void slot_app_font_size_changed (int i);
  void slot_style_currentIndexChanged (const QString &text);
  void slot_sl_icons_size_sliderMoved (int value);
  void ed_date_format_editingFinished ();
  void ed_time_format_editingFinished ();
  void cb_hl_current_line_changed (int state);
  void cb_cursor_xy_visible_changed (int state);
  void fman_naventry_confirm();

private:

/*************************
main window widgets
*************************/

  QSplitter *mainSplitter;
  QTextBrowser *man;
  QTextEdit *log_memo;
  QString charset;

  QTabWidget *main_tab_widget;
  QTabWidget *tab_options;
  QTabWidget *tab_browser;
  QTabWidget *tab_widget;
  QLineEdit *fte;


  QMenu *fileMenu;
  QMenu *editMenu;
  QMenu *menu_file_configs;
  QMenu *menu_file_sessions;

  QMenu *menu_file_bookmarks;
  QMenu *menu_file_templates;
  QMenu *menu_programs;
  QMenu *menu_fn_snippets;
  QMenu *menu_fn_sessions;

  QMenu *menu_fn_scripts;
  QMenu *menu_markup;
  QMenu *menu_functions;
  QMenu *menu_functions_case;
  QMenu *menu_file_recent;
  QMenu *menu_search;
  QMenu *menu_nav;
  QMenu *menu_view;
  QMenu *menu_spell_langs;
  QMenu *helpMenu;

  QToolBar *fileToolBar;
  QToolBar *editToolBar;

  QAction *act_test;
  QAction *newAct;
  QAction *openAct;
  QAction *saveAct;
  QAction *saveAsAct;
  QAction *exitAct;
  QAction *cutAct;
  QAction *copyAct;
  QAction *closeAct;
  QAction *undoAct;
  QAction *redoAct;
  QAction *pasteAct;
  QAction *aboutAct;
  QAction *aboutQtAct;


  QGroupBox *w_places;
  QLineEdit *ed_fman_fname;
  QComboBox *cb_fman_codecs;
/*************************
prefs window widgets
*************************/

  QLineEdit *ed_date_format;
  QLineEdit *ed_time_format;
  QLineEdit *ed_locale_override;

  CShortcutEntry *ent_shtcut;
  QListWidget *lv_menuitems;

  QFontComboBox *cmb_font_name;
  QSpinBox *spb_font_size;

  QFontComboBox *cmb_app_font_name;
  QSpinBox *spb_app_font_size;

  QLineEdit *ed_fman_path;
  QListWidget *lv_places;
  QListWidget *lv_bookmarks;
  QSplitter *spl_fman;
/*************************
main window functions
*************************/

  QAction* add_to_menu (QMenu *menu,
                        const QString &caption,
                        const char *method,
                        const QString &shortkt = QString(),
                        const QString &iconpath = QString()
                        );

      //void populateFilter(QComboBox *comboBox);

  void update_dyn_menus();
  void create_paths ();
  void create_spellcheck_menu ();

  void create_main_widget();
  void createActions();
  void createMenus();
  void createOptions();
  void createManual();
  void updateFonts();
  void update_bookmarks();
  void update_templates();
  void update_snippets();
  void update_sessions();

  void update_scripts();
  void update_places_bookmarks();
  void update_programs();
  void update_charsets();
  void createToolBars();
  void createStatusBar();
  void readSettings();
  void writeSettings();
  void dragEnterEvent(QDragEnterEvent *event);
  void dropEvent(QDropEvent *event);
   //void check_url_iterate();
   void handle_commandline();
   void add_to_last_used_charsets (const QString &s);

   void fman_nav (const QString &path);

#ifndef Q_WS_WIN
   void createFman();

#endif

};


class CApplication: public QApplication
{
  Q_OBJECT

public:

  CApplication(int & argc, char **argv): QApplication (argc, argv)
               {}

  virtual ~CApplication()
          {
          }

  //void commitData(QSessionManager& manager);
  void saveState ( QSessionManager & manager );
};


#endif
